//+------------------------------------------------------------------+
//|                                              NRTR_color_line.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width3 2
#property indicator_width4 3
//---- input parameters
extern int     ATRPeriod   = 14;
extern double  Coefficient =4.0;
extern int     SignalMode  =  1; //0-off,1-on  
//---- buffers
double upLine[];
double dnLine[];
double upSignal[];
double dnSignal[];

bool   TrendUP[2];
double Extremum[2],TR,ATR,Values[100],ChannelWidth;
int    Head[2],Weight,Curr;
datetime prevTime;

int init() 
{
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- indicator line
   SetIndexBuffer(0,upLine  ); SetIndexStyle(0,DRAW_LINE ); 
   SetIndexBuffer(1,dnLine  ); SetIndexStyle(1,DRAW_LINE ); 
   SetIndexBuffer(2,upSignal); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,dnSignal); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);

   SetIndexLabel(0,"UpTrendLine");
   SetIndexLabel(1,"DnTrendLine");
   SetIndexLabel(2,"UpTrendSignal");
   SetIndexLabel(3,"DnTrendSignal");
   
   return(0);
}

int start() 
{
   int shift, i, j, limit, count_bars = IndicatorCounted();
   
   if(count_bars > 0)  limit = Bars - count_bars - 1;
   if(count_bars < 0)  return(0);    
   if(count_bars < 1)
   {
   limit = Bars - 1;
   
      for(i=Bars-1;i>0;i--) 
      { 
      upLine[i]   = EMPTY_VALUE; 
      dnLine[i]   = EMPTY_VALUE; 
      upSignal[i] = EMPTY_VALUE; 
      dnSignal[i] = EMPTY_VALUE; 
      }
   }
   
   

   for(shift=limit;shift>=0;shift--) 
   {
      if(Time[shift] != prevTime)
      {
      TrendUP[1] = TrendUP[0];
      Extremum[1]= Extremum[0];
      Head[1] = Head[0];
      prevTime = Time[shift];
      }
      
      if(shift == Bars-2)
      {
      if (Close[Bars-2] > Close[Bars-1]) TrendUP[0] = true;
      else TrendUP[0] = false;
      Extremum[0]= Close[ Bars - 2 ];
	   }
	   else
	   if(shift < Bars-2)
	   {
	   TR = High[shift] - Low[shift];
	   if ( MathAbs( High[ shift ] - Close[ shift + 1 ]) > TR ) TR = MathAbs( High[ shift ] - Close[ shift + 1 ]);
	   if ( MathAbs( Low[ shift ] - Close[ shift + 1 ]) > TR )  TR = MathAbs( Low[ shift ] - Close[ shift + 1 ]);
	     
      if (shift == Bars - 3) 
         for (j = 0; j<ATRPeriod; j++) Values[j] = TR;
	   
	   Head[0] = Head[1];
	   
	   Values[ Head[0] ] = TR;
	   ATR = 0;
	   Weight = ATRPeriod;
	   Curr = Head[0];
         for (j = 0; j<ATRPeriod; j++) 
	      {
		   ATR += Values[ Curr ] * Weight;
		   Weight -= 1;
		   Curr -= 1;
		   if ( Curr == -1 ) Curr = ATRPeriod - 1;
	      }
	   
	   ATR = ( 2.0 * ATR ) / ( ATRPeriod * ( ATRPeriod + 1.0 ));
	   Head[0] += 1;
	   if (Head[0] == ATRPeriod) Head[0] = 0;
	   ChannelWidth = Coefficient * ATR;
	   
	   TrendUP[0] = TrendUP[1];
	   Extremum[0]= Extremum[1];
	   
         if (TrendUP[0] && ( Low[ shift ] < ( Extremum[0] - ChannelWidth ) ) )  
	      {
		   TrendUP[0] = false;
		   Extremum[0] = High[ shift ];
	      }
	   
         if ( !TrendUP[0] && ( High[ shift ] > ( Extremum[0] + ChannelWidth) ) ) {
		   TrendUP[0] = true;
		   Extremum[0] = Low[ shift ];
         }
	
         if ( TrendUP[0] && ( Low[shift] > Extremum[0] ) ) Extremum[0] = Low[ shift ];
         if ( !TrendUP[0] && ( High[ shift ] < Extremum[0] ) ) Extremum[0] = High[ shift ];
	
      upLine[shift]   = EMPTY_VALUE;               
      dnLine[shift]   = EMPTY_VALUE;    
      upSignal[shift] = EMPTY_VALUE;               
      dnSignal[shift] = EMPTY_VALUE;     
         
         if (TrendUP[0]) 
         {
		   upLine[shift] = Extremum[0] - ChannelWidth;
		   if(SignalMode > 0 && TrendUP[0] != TrendUP[1]) upSignal[shift] = upLine[shift];     
	      } 
	      else 
	      {
		   dnLine[shift] = Extremum[0] + ChannelWidth;
	      if(SignalMode > 0 && TrendUP[0] != TrendUP[1]) dnSignal[shift] = dnLine[shift];    
	      }
	   }
	}
}

